if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Trail Lifetime", "Burning Player", "Pref::Server::FlamingPlayer::TrailStickTime", "int 10 100", "Server_BurningPlayer", 10, 0, 0);
}
else
{
	if((%val = $Pref::Server::FlamingPlayer::TrailStickTime) $= "")%val = 10;if(%val > 100)%val = 100;if(%val < 10)%val = 10;
	$Pref::Server::FlamingPlayer::TrailStickTime = %val;
}

registerOutputEvent("Player", "StartFlameTrail", "", 0);
registerOutputEvent("Player", "ClearFlameTrail", "", 0);

datablock PlayerData(FlamingPlayer : PlayerStandardArmor)
{
	minJetEnergy = 0;	//Direct rip from Player_NoJet.cs
	jetEnergyDrain = 0;	//but PlayerStandardArmor isn't an add-on
	canJet = 0;		//while Player_No_Jet is
	
	uiName = "Burning Player";
	showEnergyBar = false;
};

package FlamingBlockhead
{
	function Armor::onAdd(%data, %this)
	{
		if(%data.getID() == FlamingPlayer.getID())
			%this.trailOfFlame();
		Parent::onAdd(%data, %this);
	}
	
	function Player::changeDatablock(%pl, %data)
	{
		%burning = %pl.getDatablock().getID() == FlamingPlayer.getID();
		Parent::changeDatablock(%pl, %data);
		if(%pl.getDatablock().getID() == FlamingPlayer.getID())
		{
			if(!%burning)
				%pl.trailOfFlame();
		}
		else if(%burning)
			cancel(%pl.trailOfFlame);
	}
	
	function servercmdCancelEvents(%cl)
	{
		if(isObject(%cl.player) && isEventPending(%cl.player.trailOfFlame))
			%clearTrail = 1;
		Parent::servercmdCancelEvents(%cl);
		if(%clearTrail)
			for(%i=FlameTrails.getCount()-1;%i>=0;%i--)
				if(!isEventPending((%obj = FlameTrails.getObject(%i)).delete))
					%obj.delete();
	}
};
activatePackage("FlamingBlockhead");

function Player::trailOfFlame(%pl)
{
	cancel(%pl.trailOfFlame);
	if(!isObject(%pl) || $NoFlameTrails)
		return;
	%flame = new ParticleEmitterNode()
	{
		datablock = GenericEmitterNode;
		emitter = BurnEmitterA;
		position = %pl.position;
	};
	FlameTrails.add(%flame);
	%flame.delete = %flame.schedule($Pref::Server::FlamingPlayer::TrailStickTime * 100, "delete");
	%pl.trailOfFlame = %pl.schedule(100, "trailOfFlame");
}

function Player::startFlameTrail(%pl)
{
	if(!isEventPending(%pl.trailOfFlame))
		%pl.trailOfFlame();
}

function Player::clearFlameTrail(%pl)
{
	if(%pl.getDatablock().getID() == FlamingPlayer.getID())   //Can't stop an ETERNALLY BURNING object from burning
		return;
	cancel(%pl.trailOfFlame);
}

function servercmdClearFlameTrails(%cl)
{
	if(%cl.isAdmin || %cl.isSuperAdmin)
	{
		if(FlameTrails.getCount() != 0)
			MessageAll('MsgClearBricks', "\c3"@%cl.name@"\c2 cleared all flame trails.");
		for(%i=FlameTrails.getCount()-1;%i>=0;%i--)
			FlameTrails.getObject(%i).delete();
		$NoFlameTrails = 1;
		schedule(1000, 0, "eval", "$NoFlameTrails = 0;");
	}
}

function servercmdClearOrphanedFlameTrails(%cl)
{
	if(%cl.isAdmin || %cl.isSuperAdmin)
	{
		for(%i=FlameTrails.getCount()-1;%i>=0;%i--)
			if(!isEventPending((%obj = FlameTrails.getObject(%i)).delete))
			{
				%obj.delete();
				%cleared = 1;
			}
		if(%cleared)
			MessageAll('MsgClearBricks', "\c3"@%cl.name@"\c2 cleared all orphaned flame trails.");
	}
}

new SimGroup(FlameTrails);